/*
_________________________
 <<<<<<  MaaS Japan http://maasjapan.com  >>>>>>
_________________________

Output 3D-DXF

c[pX DXF ɕϊ܂B

== ( CAD ł̕ϊeXg 2015-08)
SoliWorks 2015: outPoint=>, useBlock=>, VKi=>3DJ[u܂̓f
Mastercam X9: useBlocku͂vłubN͖  MCIvV
DraftSight(3): ftHĝ܂
Inventor: ϊł
DWG TrueViewer(Q): ϊł
JW_CAD(2): out3DArc=>, useBlocku͂vłubN͖
JacConvert(2): out3DArc=>, out3DArc=>, useBlocku͂vłubN͖

History:
2015-08-28 first version
*/

description = "DXF";
vendor = "MaaS Japan";
vendorUrl = "http://maasjapan.com";
certificationLevel = 2;

extension = "dxf";
allowHelicalMoves = true;
allowedCircularPlanes = undefined;
maximumCircularSweep = toRad(180);

properties = {
  outRapid: true,  // 肪svȂuv
  outPoint: true,  // _\svȂuv
  out3DArc: true,  // uvȂ R~ʂ𒼐 (2 CAD ̏ꍇׂ͂)
  useBlock: true   // uvȂ ubNgȂ (SolidWorks ͂̕悢ł傤)
};

var grpFormat = createFormat({width:3,decimals:0});
var xyzFormat = createFormat({decimals:15, forceDecimal:true});
var z3Format  = createFormat({decimals:3, forceDecimal:true});
var nFormat   = createFormat({width:5, zeropad:true});
var xOutput, yOutput, zOutput;  // define in onOpen()
var blocks=[], blockLayer, pnts=[];

function writeB() {
  if (arguments.length%2) error("writeB( ... odd number argument);");
  for(var i=0;i<arguments.length;i=i+2) {
    writeln(grpFormat.format(arguments[i]));
    writeln(arguments[i+1]);
  }
}

function onOpen() {
  xOutput = createVariable({force:true},xyzFormat);
  yOutput = createVariable({force:true},xyzFormat);
  zOutput = createVariable({force:true},xyzFormat);
//
  writeB(0,"SECTION",  2,"HEADER");
    writeB(9,"$PDMODE",  70,36,    // shape of point 
           9,"$PDSIZE",  40,0.1,   // display-size of point
           9,"$DIMALTF", 40,0.1);  // mm (not inch)
  writeB(0,"ENDSEC");
  writeB(0,"SECTION",  2,"TABLES");
    writeB(0,"TABLE",  2,"LTYPE", 70, 4);
      writeB(0,"LTYPE", 2,"BYBLOCK",    70,0,   3,"",           72,65, 73,0, 40,0.0);
      writeB(0,"LTYPE", 2,"BYLAYER",    70,0,   3,"",           72,65, 73,0, 40,0.0);
      writeB(0,"LTYPE", 2,"CONTINUOUS", 70,0,   3,"Solid line", 72,65, 73,0, 40,0.0);
      writeB(0,"LTYPE", 2,"DASHED",     70,0,   3,"Dashed __ __ __ __ __ __ __ __ __ __ __ __ __",     72,65, 73,2, 40,0.375,  49,0.25, 74,0, 49,-0.125, 74,0);
    writeB(0,"ENDTAB");
    writeB(0,"TABLE",  2,"LAYER", 70, 5);
      writeB(0,"LAYER", 2,"0",         70,0,   62,7,  6,"CONTINUOUS");
      writeB(0,"LAYER", 2,"Rapid",     70,0,   62,5,  6,"DASHED"    );  // G00
      writeB(0,"LAYER", 2,"Rapid-P",   70,0,   62,5,  6,"DASHED"    );  // G00
      writeB(0,"LAYER", 2,"Cutting",   70,0,   62,7,  6,"CONTINUOUS");  // G01 or G02 or G03
      writeB(0,"LAYER", 2,"Cutting-P", 70,0,   62,7,  6,"CONTINUOUS");  // G01 or G02 or G03
    writeB(0,"ENDTAB");
  writeB(0,"ENDSEC");
  if (properties.useBlock) {
    writeB(0,"SECTION",  2,"BLOCKS");
  } else {
    writeB(0,"SECTION",  2,"BLOCKS",  0,"ENDSEC");
    writeB(0,"SECTION",  2,"ENTITIES");
  }
}

function onLinear(x, y, z) {
  if (properties.useBlock) onBlock("Cutting");
  if (isFinite(xOutput.getCurrent())) writeB(
     0,"LINE", 8,(properties.useBlock ? "0":"Cutting"),
    10,xyzFormat.format(xOutput.getCurrent()),
    20,xyzFormat.format(yOutput.getCurrent()),
    30,xyzFormat.format(zOutput.getCurrent()),
    11,xOutput.format(x),
    21,yOutput.format(y),
    31,zOutput.format(z) );
  point(x,y,z, "Cutting-P");
}

function onCircular(clockwise, cx, cy, cz, x, y, z) {
  if (properties.useBlock) onBlock("Cutting");
  var is3DArc=(getCircularPlane()!=PLANE_XY);
  var fw=getCircularNormal(),rt, mm, a50,a51;
  rt = Vector.cross(new Vector(0,0,1),fw);
  if (rt.isZero()) rt = new Vector(1,0,0);
  mm = (new Matrix(rt,Vector.cross(fw,rt),fw)).getTransposed();
  v1 = mm.multiply(new Vector(xOutput.getCurrent()-cx, yOutput.getCurrent()-cy, zOutput.getCurrent()-cz));
  v2 = mm.multiply(new Vector(x-cx, y-cy, z-cz));
  if (!properties.out3DArc && is3DArc || Math.abs(v1.z-v2.z)>1e-6) {linearize(tolerance); return;}
  a50 = toDeg(v1.getXYAngle());
  a51 = toDeg(v2.getXYAngle());
  if (a50<0) a50+=360
  if (a51<0) a51+=360
  if (clockwise) {var tmp=a50; a50=a51; a51=tmp;}
  cx=mm.multiply(new Vector(cx,cy,cz)); cy=cx.y; cz=cx.z; cx=cx.x
//  if (isFullCircle()) // ref. maximumCircularSweep
  writeB(
     0,"ARC", 8,"Cutting",
    10,xyzFormat.format(cx),
    20,xyzFormat.format(cy),
    30,xyzFormat.format(cz),
    40,xyzFormat.format(getCircularRadius()),
    50,xyzFormat.format(a50),
    51,xyzFormat.format(a51) );
  if (getCircularPlane()!=PLANE_XY) writeB(
    210,xyzFormat.format(fw.x),
    220,xyzFormat.format(fw.y),
    230,xyzFormat.format(fw.z) );
  point(x,y,z, "Cutting-P");
}

function point(x,y,z, layer) {
  xOutput.format(x); yOutput.format(y); zOutput.format(z);
  if (properties.useBlock) {
    var blk=blocks[blocks.length-1];
    if (blk.minZ-z>0.001) blk.minZ=z;
    if (z-blk.maxZ>0.001) blk.maxZ=z;
  }
  if (!properties.outPoint || layer!="Cutting-P" && !properties.outRapid) return;
  if (properties.useBlock) {
    pnts.push(new Vector(x,y,z));
  } else {
    writeB(0,"POINT", 8,layer, 10,xOutput.format(x), 20,yOutput.format(y), 30,zOutput.format(z));
  }
}

function onBlock(layer) {
  if (blockLayer==layer) return;
  if (blockLayer) { // end of block
    var blk=blocks[blocks.length-1], s=getRedirectionBuffer();
    closeRedirection();
    blk.blockName = blockLayer.substring(0,1) + nFormat.format(Math.floor(blocks.length/2)) + "_Z" + z3Format.format(blk.minZ).replace(/[.]/,"_");
    blk.d0[5] = blk.d0[15] = blk.blockName;
    writeB.apply(this,blk.d0);
    write(s);
    writeB(0,"ENDBLK");
    if (pnts.length>0) {
      blk.pntName="U"+blk.blockName;
      writeB(0,"BLOCK", 8,"0", 2,blk.pntName, 70,0, 10,"0.0", 20,"0.0", 30,"0.0", 3,blk.pntName);
      writeB(66,1, 0,"ATTRIB", 8,0, 2,"maxZ/minZ",70,0);
      pnts.forEach(function(p) {writeB(0,"POINT", 8,0, 10,xyzFormat.format(p.x), 20,xyzFormat.format(p.y), 30,xyzFormat.format(p.z));});
      pnts=[];
      writeB(0,"ENDBLK");
    }
  }
  if (layer) { // start block
    blocks.push({
      blockName:"blockName",
      layer: layer,
      d0: [0,"BLOCK", 8,"0", 2,"blockName", 70,0, 10,"0.0", 20,"0.0", 30,"0.0", 3,"blockName"],
      minZ:1000.0, maxZ:-1000.0, p0:getCurrentPosition()});
    redirectToBuffer();
  }
  blockLayer = layer;
}

function onRapid(x, y, z) {
  if (properties.useBlock) onBlock("Rapid");
  if (isFinite(xOutput.getCurrent()) && properties.outRapid) writeB(
     0,"LINE", 8,"Rapid",
    10,xyzFormat.format(xOutput.getCurrent()),
    20,xyzFormat.format(yOutput.getCurrent()),
    30,xyzFormat.format(zOutput.getCurrent()),
    11,xOutput.format(x),
    21,yOutput.format(y),
    31,zOutput.format(z) );
  point(x,y,z, "Rapid-P");
}

function onClose() {
  onBlock();
  if (properties.useBlock) {
    writeB(0,"ENDSEC");
    writeB(0,"SECTION",  2,"ENTITIES");
    blocks.forEach(function(blk) {
      writeB(0,"INSERT", 2,blk.blockName, 8,blk.layer, 10,"0.0", 20,"0.0", 30,"0.0");
      if (blk.layer.match(/Cutting/)) writeB(
         6,1, 0,"ATTRIB", 8,0,
        10,xyzFormat.format(blk.p0.x), 20,xyzFormat.format(blk.p0.y), 30,xyzFormat.format(blk.p0.z),
         1,""+z3Format.format(blk.maxZ)+"/ "+z3Format.format(blk.minZ), 2,"maxZ/minZ",70,1);
      if (blk.pntName) writeB(0,"INSERT", 2,blk.pntName, 8,blk.layer+"-P", 10,"0.0", 20,"0.0", 30,"0.0");
    });
    writeB(0,"ENDSEC", 0,"EOF");
  } else {
    writeB(0,"ENDSEC", 0,"EOF");
  }
}
